
; DCF77-MODUL									
; Bernhard.Erfurt@gmx.de						
; 10/2011										
;												

; PROTOKOLL SLAVE=>MASTER						
; BYTE-0 ==>	(adr_DCF_GUELTIG)				
; BYTE-1 ==>	(adr_DCF_ZEIGER)				
; BYTE-2 ==>	(adr_DCF_STATUS)				
; BYTE-3 ==>	(adr_ss)						
; BYTE-4 ==>	(adr_mm)						
; BYTE-5 ==>	(adr_hh)						
; BYTE-6 ==>	(adr_TAG)						
; BYTE-7 ==>	(adr_MONAT)						
; BYTE-8 ==>	(adr_JAHR)						
; BYTE-9 ==>	(adr_WOCHENTAG)					
; BYTE-10 ==>	(adr_DCF_SOMMERZEIT)			

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> LED GRN								
; PB1 ==> LED GELB								
; PB2 ==> LED ROT								
; PB3 ==> 										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> Quarz	16MHz							
; PB7 ==> Quarz	16MHz							
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> SDA									
; PC5 ==> SCL									
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> DCF-EINGANG							
; PD4 ==> 										
; PD5 ==> 										
; PD6 ==> 										
; PD7 ==> 										
;												


; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT		=16000000			; 16 MHz	
; TIMER-WERTE					
.equ TIMERWERT0 =256-250			;(2 hoch 8  minus 250)		bei 16MHz + Vorteiler   64 => 0.001s =1ms	
; SLAVE-ADRESSE									
.equ TWI_SLAVE_ADRESSE		=110
; GENERAL CALL									
.equ TWI_GENERAL_CALL_ENABLE=0
; TWI Slave Receiver Codes						
.equ TW_SR_SLA_ACK        	= 0x60
.equ TW_SR_ARB_LOST_SLA_ACK = 0x68
.equ TW_SR_GCALL_ACK      	= 0x70
.equ TW_SR_ARB_LOST_GCALL_ACK=0x78
.equ TW_SR_DATA_ACK      	= 0x80
.equ TW_SR_DATA_NACK      	= 0x88
.equ TW_SR_GCALL_DATA_ACK   = 0x90
.equ TW_SR_GCALL_DATA_NACK  = 0x98
.equ TW_SR_STOP        		= 0xA0
; TWI Slave Transmitter Codes					
.equ TW_ST_SLA_ACK        	= 0xA8
.equ TW_ST_ARB_LOST_SLA_ACK = 0xB0
.equ TW_ST_DATA_ACK      	= 0xB8
.equ TW_ST_DATA_NACK      	= 0xC0
.equ TW_ST_LAST_DATA      	= 0xC8
.equ TW_NO_INFO        		= 0xF8
.equ TW_BUS_ERROR        	= 0x00
; LEDS 											
.equ LED_B_GRUEN	= 0				; DCF-Signal ok	
.equ LED_B_GELB		= 1				; DCF-SIGNAL	
.equ LED_B_ROT		= 2				; ERROR			
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					=0x0060			; 0x0060 START Adresse 		

.equ adr_ss_VT					=0x0060+6			; Vorteiler	
.equ adr_ss_100					=0x0060+7			; 100-el	
.equ adr_ss						=0x0060+8			; Sekunden	
.equ adr_mm						=0x0060+10			; Minuten	
.equ adr_hh						=0x0060+11			; Stunden	
.equ adr_TAG					=0x0060+13			; Tag		
.equ adr_WOCHENTAG				=0x0060+14			; WochenTag	
.equ adr_MONAT					=0x0060+15			; Monat		
.equ adr_JAHR					=0x0060+16			; Jahr		
.equ adr_SOMMERZEIT				=0x0060+17			; SOMMERZEIT 0/1

.equ adr_DATEN_ZEIGER			= 0x0060+50			; TWI-DATEN ZEIGER

.equ adr_DCF_mm					=0x0060+220			; Minuten 	aus DCF-Protokoll	
.equ adr_DCF_hh					=0x0060+221			; Stunden 	aus DCF-Protokoll	
.equ adr_DCF_TAG				=0x0060+222			; Tag	 	aus DCF-Protokoll	
.equ adr_DCF_WOCHENTAG			=0x0060+223			; WochenTag aus DCF-Protokoll	
.equ adr_DCF_MONAT				=0x0060+224			; Monat	 	aus DCF-Protokoll	
.equ adr_DCF_JAHR				=0x0060+225			; Jahr	 	 aus DCF-Protokoll		
.equ adr_DCF_SOMMERZEIT			=0x0060+226			; SOMMERZEIT aus DCF-Protokoll	

.equ adr_DCF_PEGEL				=0x0060+290			; DCF-Pegel am PIN			
.equ adr_DCF_PEGEL_OLD			=0x0060+291			; DCF-Pegel am PIN			
.equ adr_DCF_PEGEL_WECHSEL		=0x0060+292			; bei Pegel-Wechsel=1		
.equ adr_DCF_IMPULSLAENGE		=0x0060+293			; DCF gemessene Impulslnge	
.equ adr_DCF_IMPULSLAENGE_AN	=0x0060+290			; DCF Empulslnge Trger an	
.equ adr_DCF_IMPULSLAENGE_AUS	=0x0060+291			; DCF Empulslnge Trger aus
.equ adr_DCF_BIT				=0x0060+292			; DCF-BIT					

.equ adr_DCF_GUELTIG			=0x0060+301			; DCF-Protokoll ist geprft und gltig			
.equ adr_DCF_STATUS				=0x0060+302			; 
.equ adr_DCF_ZEIGER				=0x0060+303			; Zeiger fr DCF-FELD			
.equ adr_DCF_BEREICH			=0x0060+304	 		; 60 BYTES fr DCF-FELD			

.equ adr_SRAM_CHECK				= 0x0060+900


; REGISTER										

.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR  	; Timer1 Overflow Handler           					
rjmp TIM0_OVF			;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR 	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp TWSI       		; Two-wire Serial Interface Handler 					
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	cbi PORTB, LED_B_ROT	; an	
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM CLEAR										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	
; PORT B initialisieren								
	ldi temp, 0b00000111	; LED/LED/LED
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000111	
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; SDA/SCL	
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000	; DCF77
	out DDRD, temp			
; PORT D setzen										
	ldi temp, 0b00001000	; PULL-UPS-EIN			
	out PORTD, temp				

; Watchdog aktivieren (max. Zeit)					
	rcall Watchdog_aktivieren
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR

; TIMER0_INITIALISIERUNG							
	rcall TIMER0_INITIALISIERUNG
; TIMER aktivieren									
	rcall TIMER_AKTIVIEREN
; I2C/TWI INITIALISIEREN							
	rcall TWI_INI
; Startwerte										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; ZEIT				
	ldi temp,0
	STS(adr_hh),temp
	ldi temp,0
	STS(adr_mm),temp
	ldi temp,0
	STS(adr_ss),temp
	; DATUM				
	ldi temp,1
	STS(adr_TAG),temp
	ldi temp,1
	STS(adr_MONAT),temp
	ldi temp,1
	STS(adr_JAHR),temp
	; SOMMERZEIT		
	STS(adr_SOMMERZEIT),NULL
	; SRAM-CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp

; LED-TEST											
	sbi PORTB, LED_B_GRUEN	; aus	
	sbi PORTB, LED_B_GELB	; aus	
	sbi PORTB, LED_B_ROT	; aus	

; interrupts freigeben								
	sei


; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	wdr
	rcall PROGRAMM_CHECK
	rcall BUS_BELEGT_CHECK
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "DCF77_TIMER.asm"
.include "DCF77_SONSTIGES.asm"
.include "DCF77_DCF.asm"
.include "DCF77_I2C_SLAVE.asm"
.include "DCF77_16MHZwait.asm"
; ##############################################################################
; ##############################################################################
; ##############################################################################





