;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_PIN_ABFRAGEN:
	; PORT einlesen		
	in temp,PIND				
	; PIN selektieren	
	andi temp, 0b00001000		
	; vergleich			
	tst temp					
	breq DCF_PIN_ABFRAGEN_LOW	; ist LOW, dann...	
	; PEGEL ist HIGH	
	STS(adr_DCF_PEGEL),EINS 	; 1					
	sbi PORTB, LED_B_GELB		; aus	
	ret
DCF_PIN_ABFRAGEN_LOW:
	; PEGEL ist LOW		
	STS(adr_DCF_PEGEL),NULL		; 0					
	cbi PORTB, LED_B_GELB		; an	
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_PIN_PEGELWECHSEL_ERKENNUNG:
	; Hat sich Pegel gendert ?
	LDS temp, (adr_DCF_PEGEL)		; laden		
	LDS temp1,(adr_DCF_PEGEL_OLD)	; laden		
	cp temp,temp1					; vergleich	
	brne DCF_PIN_PEGELWECHSEL_ERKANNT
	ret
DCF_PIN_PEGELWECHSEL_ERKANNT:
	; Pegel hat sich gendert	
	STS(adr_DCF_PEGEL_OLD),temp
	STS (adr_DCF_PEGEL_WECHSEL),EINS
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_IMPULSLAENGE:
	; Impulslnge +1				
	LDS temp,(adr_DCF_IMPULSLAENGE)
	inc temp
	STS(adr_DCF_IMPULSLAENGE),temp
	; Fehlerprfung Impulslnge min	(60ms)
	cpi temp,6
	brsh DCF_IMPULSLAENGE_MIN_OK
	; FEHLER						
	STS (adr_DCF_PEGEL_WECHSEL),NULL
	ret
DCF_IMPULSLAENGE_MIN_OK:
	; Fehlerprfung Impulslnge max	
	cpi temp,255 
	brne DCF_IMPULSLAENGE_MAX_OK
	; FEHLER						
	STS(adr_DCF_IMPULSLAENGE),NULL
	STS (adr_DCF_PEGEL_WECHSEL),NULL
	ret
DCF_IMPULSLAENGE_MAX_OK:
;-------------------------------------------------------------------------
	; fand ein PEGELWECHSEL statt ?	
	LDS temp,(adr_DCF_PEGEL_WECHSEL)
	tst temp
	brne DCF_IMPULSLAENGE_PEGEL_WECHSEL
	ret
;-------------------------------------------------------------------------
DCF_IMPULSLAENGE_PEGEL_WECHSEL:
	STS (adr_DCF_PEGEL_WECHSEL),NULL

	; "AN" oder "AUS" Pegel?		
	LDS temp,(adr_DCF_PEGEL)
	tst temp
	breq DCF_IMPULSLAENGE_AN
;-------------------------------------------------------------------------
DCF_IMPULSLAENGE_AUS:
	; Impulslnge bernehmen
	LDS temp,(adr_DCF_IMPULSLAENGE)
	STS (adr_DCF_IMPULSLAENGE_AUS),temp
	STS(adr_DCF_IMPULSLAENGE),NULL
	; Impulslnge auswerten	100ms=LOW 200ms=HIGH
	LDS temp,(adr_DCF_IMPULSLAENGE_AUS)
	cpi temp,12
	brsh DCF_IMPULSLAENGE_AUS_HIGH
	; DCF-BIT LOW			
DCF_IMPULSLAENGE_AUS_LOW:
	STS(adr_DCF_BIT),NULL	; DCF-BIT = 0	
	rcall DCF_DATENFELD_SCHREIBEN
	ret
	; DCF-BIT HIGH			
DCF_IMPULSLAENGE_AUS_HIGH:
	STS(adr_DCF_BIT),EINS	; DCF-BIT = 1	
	rcall DCF_DATENFELD_SCHREIBEN
	ret
;-----------------------------------------------
DCF_IMPULSLAENGE_AN:
	; Impulslnge bernehmen
	LDS temp,(adr_DCF_IMPULSLAENGE)
	STS (adr_DCF_IMPULSLAENGE_AN),temp
	STS(adr_DCF_IMPULSLAENGE),NULL
	; grer als 1,5 Sekunden==> Minutenstart ?
	cpi temp,150
	brsh DCF_MINUTENSTART
	ret
;---- Minutenanfang erkannt --------------------
DCF_MINUTENSTART:
	; DCF GUELTIG auf NULL setzen		
	STS(adr_DCF_GUELTIG),NULL	
	; ##### DCF-Zeit aus Protokoll errechnen ######### !!!
	rcall DCF_ZEIT
	; DCF-ZEIGER NULL	
	STS(adr_DCF_ZEIGER),NULL
	; Fehler Prfung	
	LDS temp,(adr_DCF_GUELTIG)
	tst temp
	brne DCF_ZEIT_OK
;------------------------------------------------------------
DCF_ZEIT_ERROR:
	; LED GRN			
	sbi PORTB, LED_B_GRUEN	; AUS	
	ret
;------------------------------------------------------------
DCF_ZEIT_OK:
	; DCF-ZEIT ist korrekt !!!		 
	; LED GRN			
	cbi PORTB, LED_B_GRUEN	; AN	

	; SEKUNDEN auf NULL			
	STS(adr_ss_VT),NULL
	STS(adr_ss_100),NULL
	STS(adr_ss),NULL
	; MINUTEN					
	LDS temp,(adr_DCF_mm) 				; aus SRAM laden	
	STS (adr_mm),temp					; in SRAM speichern	
	; STUNDEN					
	LDS temp,(adr_DCF_hh) 				; aus SRAM laden	
	STS (adr_hh),temp					; in SRAM speichern	
	; TAG						
	LDS temp,(adr_DCF_TAG) 				; aus SRAM laden	
	STS (adr_TAG),temp					; in SRAM speichern	
	; Wochentag					
	LDS temp,(adr_DCF_WOCHENTAG) 		; aus SRAM laden	
	STS (adr_WOCHENTAG),temp			; in SRAM speichern	
	; MONAT						
	LDS temp,(adr_DCF_MONAT) 			; aus SRAM laden	
	STS (adr_MONAT),temp				; in SRAM speichern	
	; JAHR						
	LDS temp,(adr_DCF_JAHR) 			; aus SRAM laden	
	STS (adr_JAHR),temp					; in SRAM speichern	
	; MESZ						
	LDS temp,(adr_DCF_SOMMERZEIT) 		; aus SRAM laden	
	STS (adr_SOMMERZEIT),temp			; in SRAM speichern	
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_DATENFELD_SCHREIBEN:
	; Z-ZEIGER initialisieren	
	LDI ZL, low(adr_DCF_BEREICH)
	LDI ZH,high(adr_DCF_BEREICH)
	; DCF-ZEIGER laden			
	LDS temp, (adr_DCF_ZEIGER)
	; Fehlerprng			
	cpi temp,59
	brlo DCF_DATENFELD_SCHREIBEN_OK
	; ERROR					
	STS (adr_DCF_ZEIGER),NULL
	ret
DCF_DATENFELD_SCHREIBEN_OK:
	; addieren					
	add ZL,temp
	adc ZH,NULL
	; DCF ZEIGER +1				
	inc temp
	STS (adr_DCF_ZEIGER),temp
	; DCF-BIT in's Datenfeld schreiben	
	LDS temp,(adr_DCF_BIT)
	ST Z,temp
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;Bit(s) Anzahl 		Bedeutung 												
; 0 	1 bit	Start einer neuen Minute (ist immer "0") 					
;15 				Rufbit (bis Mitte 2003: Reserveantenne) 				
;16 				"1": Am Ende dieser Stunde wird MEZ/MESZ umgestellt. 	
;17 				"0": MEZ, "1": MESZ 									
;18 				"0": MESZ, "1": MEZ 									
;19 				"1": Am Ende dieser Stunde wird eine Schaltsekunde eingefgt. 
;20 		1 bit 	Beginn der Zeitinformation (ist immer "1") 				
;21-27 		7 bit 	Minute (Werte der einzelnen Bits: 1,2,4,8,10,20,40) 	
;28 		1 bit 	Paritt Minute 											
;29-34 		6 bit 	Stunde (1, 2, 4, 8, 10, 20) 							
;35 		1 bit 	Paritt Stunde 											
;36-41 		6 bit 	Monatstag (1, 2, 4, 8, 10, 20) 							
;42-44 		3 bit 	Wochentag (1, 2, 4) 									
;45-49 		5 bit 	Monat (1, 2, 4, 8, 10) 									
;50-57 		8 bit 	Jahr (zweistellig; 1, 2, 4, 8, 10, 20, 40, 80) 			
;58 		1 bit 	Paritt Datum 											
DCF_ZEIT:

; DCF-Zeiger muss auf 59 stehen												
DCF_ZEIT_ZEIGER:
	LDS temp, (adr_DCF_ZEIGER)
	cpi temp,59
	breq DCF_ZEIT_ZEIGER_OK
	ret
DCF_ZEIT_ZEIGER_OK:
;0 			1 bit	Start einer neuen Minute (ist immer "0") 				
DCF_ZEIT_00:
	LDS temp,(adr_DCF_BEREICH+0)			; aus SRAM laden	
 	tst temp 
	breq DCF_ZEIT_01
	ret
DCF_ZEIT_01:
;17 SOMMERZEIT				"0": MEZ, "1": MESZ 									
	LDS temp,(adr_DCF_BEREICH+17)			; aus SRAM laden	
	STS (adr_DCF_SOMMERZEIT),temp			; im SRAM ablegen	
;20 		1 bit 	Beginn der Zeitinformation (ist immer "1") 	
DCF_ZEIT_20:
	LDS temp,(adr_DCF_BEREICH+20)			; aus SRAM laden	
 	tst temp 
	brne DCF_ZEIT_21
	ret
;21-27 		7 bit 	Minute (Werte der einzelnen Bits: 1,2,4,8,10,20,40) 	
DCF_ZEIT_21:
	clr temp1
	LDS temp,(adr_DCF_BEREICH+21)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_22
	subi temp1,-1 
DCF_ZEIT_22:
	LDS temp,(adr_DCF_BEREICH+22)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_23
	subi temp1,-2 
DCF_ZEIT_23:
	LDS temp,(adr_DCF_BEREICH+23)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_24
	subi temp1,-4 
DCF_ZEIT_24:
	LDS temp,(adr_DCF_BEREICH+24)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_25
	subi temp1,-8 
DCF_ZEIT_25:
	LDS temp,(adr_DCF_BEREICH+25)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_26
	subi temp1,-10 
DCF_ZEIT_26:
	LDS temp,(adr_DCF_BEREICH+26)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_27
	subi temp1,-20 
DCF_ZEIT_27:
	LDS temp,(adr_DCF_BEREICH+27)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_28
	subi temp1,-40 
;28 		1 bit 	Paritt Minute 											
DCF_ZEIT_28:
	; Paritt berechnen			
	clr temp2
	LDS temp,(adr_DCF_BEREICH+21) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+22) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+23) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+24) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+25) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+26) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+27) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	; BIT-MUSTER (bei gerader Anzahl von HIGH = NULL)
	andi temp2,0b00000001
	; Paritt laden				
	LDS temp,(adr_DCF_BEREICH+28) 			; aus SRAM laden	
	; Paritt vergleichen		
	cp temp2,temp
	breq DCF_ZEIT_28_OK
	ret
DCF_ZEIT_28_OK:
	; MINUTENWERT bernehmen	
	STS(adr_DCF_mm),temp1

;29-34 		6 bit 	Stunde (1, 2, 4, 8, 10, 20) 							
DCF_ZEIT_29:
	clr temp1
	LDS temp,(adr_DCF_BEREICH+29)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_30
	subi temp1,-1 
DCF_ZEIT_30:
	LDS temp,(adr_DCF_BEREICH+30)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_31
	subi temp1,-2 
DCF_ZEIT_31:
	LDS temp,(adr_DCF_BEREICH+31)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_32
	subi temp1,-4 
DCF_ZEIT_32:
	LDS temp,(adr_DCF_BEREICH+32)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_33
	subi temp1,-8 
DCF_ZEIT_33:
	LDS temp,(adr_DCF_BEREICH+33)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_34
	subi temp1,-10 
DCF_ZEIT_34:
	LDS temp,(adr_DCF_BEREICH+34)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_35
	subi temp1,-20 
;35 		1 bit 	Paritt Stunde 											
DCF_ZEIT_35:
	; Paritt berechnen		
	clr temp2
	LDS temp,(adr_DCF_BEREICH+29) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+30) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+31) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+32) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+33) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+34) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	; BIT-MUSTER (bei gerader Anzahl von HIGH = NULL)
	andi temp2,0b00000001
	; Paritt laden				
	LDS temp,(adr_DCF_BEREICH+35) 			; aus SRAM laden	
	; Paritt vergleichen		
	cp temp2,temp
	breq DCF_ZEIT_35_OK
	ret
DCF_ZEIT_35_OK:
	; STUNDENWERT bernehmen	
	STS(adr_DCF_hh),temp1
;36-41 		6 bit 	Monatstag (1, 2, 4, 8, 10, 20) 							
DCF_ZEIT_36:
	clr temp1
	LDS temp,(adr_DCF_BEREICH+36)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_37
	subi temp1,-1 
DCF_ZEIT_37:
	LDS temp,(adr_DCF_BEREICH+37)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_38
	subi temp1,-2
DCF_ZEIT_38:
	LDS temp,(adr_DCF_BEREICH+38)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_39
	subi temp1,-4 
DCF_ZEIT_39:
	LDS temp,(adr_DCF_BEREICH+39)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_40
	subi temp1,-8 
DCF_ZEIT_40:
	LDS temp,(adr_DCF_BEREICH+40)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_41
	subi temp1,-10 
DCF_ZEIT_41:
	LDS temp,(adr_DCF_BEREICH+41)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_41_OK
	subi temp1,-20 
DCF_ZEIT_41_OK:
	; TAG bernehmen	
	STS(adr_DCF_TAG),temp1
;42-44 		3 bit 	Wochentag (1, 2, 4) 									
DCF_ZEIT_42:
	clr temp1
	LDS temp,(adr_DCF_BEREICH+42)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_43
	subi temp1,-1 
DCF_ZEIT_43:
	LDS temp,(adr_DCF_BEREICH+43)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_44
	subi temp1,-2 
DCF_ZEIT_44:
	LDS temp,(adr_DCF_BEREICH+44)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_44_OK
	subi temp1,-4 
DCF_ZEIT_44_OK:
	; WOCHENTAG bernehmen	
	STS(adr_DCF_WOCHENTAG),temp1
;45-49 		5 bit 	Monat (1, 2, 4, 8, 10) 									
DCF_ZEIT_45:
	clr temp1
	LDS temp,(adr_DCF_BEREICH+45)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_46
	subi temp1,-1 
DCF_ZEIT_46:
	LDS temp,(adr_DCF_BEREICH+46)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_47
	subi temp1,-2 
DCF_ZEIT_47:
	LDS temp,(adr_DCF_BEREICH+47)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_48
	subi temp1,-4 
DCF_ZEIT_48:
	LDS temp,(adr_DCF_BEREICH+48)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_49
	subi temp1,-8 
DCF_ZEIT_49:
	LDS temp,(adr_DCF_BEREICH+49)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_49_OK
	subi temp1,-10 
DCF_ZEIT_49_OK:
	; MONAT bernehmen	
	STS(adr_DCF_MONAT),temp1
;50-57 		8 bit 	Jahr (zweistellig; 1, 2, 4, 8, 10, 20, 40, 80) 			
DCF_ZEIT_50:
	clr temp1
	LDS temp,(adr_DCF_BEREICH+50)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_51
	subi temp1,-1 
DCF_ZEIT_51:
	LDS temp,(adr_DCF_BEREICH+51)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_52
	subi temp1,-2 
DCF_ZEIT_52:
	LDS temp,(adr_DCF_BEREICH+52)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_53
	subi temp1,-4 
DCF_ZEIT_53:
	LDS temp,(adr_DCF_BEREICH+53)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_54
	subi temp1,-8 
DCF_ZEIT_54:
	LDS temp,(adr_DCF_BEREICH+54)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_55
	subi temp1,-10 
DCF_ZEIT_55:
	LDS temp,(adr_DCF_BEREICH+55)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_56
	subi temp1,-20 
DCF_ZEIT_56:
	LDS temp,(adr_DCF_BEREICH+56)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_57
	subi temp1,-40 
DCF_ZEIT_57:
	LDS temp,(adr_DCF_BEREICH+57)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_57_w
	subi temp1,-80 
DCF_ZEIT_57_w:
	; Fehlerprfung Jahr >= 09	
	cpi temp1,9
	brsh DCF_ZEIT_57_OK
	ret
DCF_ZEIT_57_OK:
	; JAHR bernehmen	
	STS(adr_DCF_JAHR),temp1
;58 		1 bit 	Paritt Datum 											
DCF_ZEIT_58:
	; Paritt berechnen		
	clr temp2
	; TAG	
	LDS temp,(adr_DCF_BEREICH+36) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+37) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+38) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+39) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+40) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+41) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	; WOCHENTAG	
	LDS temp,(adr_DCF_BEREICH+42) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+43) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+44) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	; MONAT		
	LDS temp,(adr_DCF_BEREICH+45) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+46) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+47) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+48) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+49) 			; aus SRAM laden	
	add temp2,temp							; addieren	
	; JAHR		
	LDS temp,(adr_DCF_BEREICH+50) 			; aus SRAM laden	
	add temp2,temp
	LDS temp,(adr_DCF_BEREICH+51) 			; aus SRAM laden	
	add temp2,temp
	LDS temp,(adr_DCF_BEREICH+52) 			; aus SRAM laden	
	add temp2,temp
	LDS temp,(adr_DCF_BEREICH+53) 			; aus SRAM laden	
	add temp2,temp
	LDS temp,(adr_DCF_BEREICH+54) 			; aus SRAM laden	
	add temp2,temp
	LDS temp,(adr_DCF_BEREICH+55) 			; aus SRAM laden	
	add temp2,temp
	LDS temp,(adr_DCF_BEREICH+56) 			; aus SRAM laden	
	add temp2,temp
	LDS temp,(adr_DCF_BEREICH+57) 			; aus SRAM laden	
	add temp2,temp

	; BIT-MUSTER (bei gerader Anzahl von HIGH = NULL)
	andi temp2,0b00000001
	; Paritt laden				
	LDS temp,(adr_DCF_BEREICH+58) 			; aus SRAM laden	
	; Paritt vergleichen		
	cp temp2,temp
	breq DCF_ZEIT_58_OK
	ret
DCF_ZEIT_58_OK:
; --------------------------------------------------------------------------
	; Fehlerprfung STUNDE		
	LDS temp,(adr_DCF_hh)
	cpi temp,(23+1)
	brsh DCF_ERROR
	; Fehlerprfung MINUTE
	LDS temp,(adr_DCF_mm)
	cpi temp,(59+1)
	brsh DCF_ERROR
	; Fehlerprfung TAG		
	LDS temp,(adr_DCF_WOCHENTAG)
	tst temp
	breq DCF_ERROR
	cpi temp,(7+1)
	brsh DCF_ERROR
	; Fehlerprfung TAG		
	LDS temp,(adr_DCF_TAG)
	tst temp
	breq DCF_ERROR
	cpi temp,(31+1)
	brsh DCF_ERROR
	; Fehlerprfung MONAT	
	LDS temp,(adr_DCF_MONAT)
	tst temp
	breq DCF_ERROR
	cpi temp,(12+1)
	brsh DCF_ERROR
	; Fehlerprfung Jahr	
	LDS temp,(adr_DCF_JAHR)
	tst temp
	breq DCF_ERROR
	cpi temp,11
	brlo DCF_ERROR
; --------------------------------------------------------------------------
; DCF_GUELTIG				
DCF_IST_GUELTIG:
	STS(adr_DCF_GUELTIG),EINS
; --------------------------------------------------------------------------
DCF_ERROR:

ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
